'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _AccessibleSeat = require('./AccessibleSeat');

var _AccessibleSeat2 = _interopRequireDefault(_AccessibleSeat);

var _Spacer = require('./Spacer');

var _Spacer2 = _interopRequireDefault(_Spacer);

var _shortid = require('shortid');

var _shortid2 = _interopRequireDefault(_shortid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Seat = function (_React$Component) {
  _inherits(Seat, _React$Component);

  function Seat(props) {
    _classCallCheck(this, Seat);

    var _this = _possibleConstructorReturn(this, (Seat.__proto__ || Object.getPrototypeOf(Seat)).call(this, props));

    _this.state = {};

    _this.handleClick = _this.handleClick.bind(_this);
    _this.handleFocus = _this.handleFocus.bind(_this);
    return _this;
  }

  _createClass(Seat, [{
    key: 'handleClick',
    value: function handleClick() {
      if (this.props.seat.status != 'unavailable') {
        var row = this.props.row;
        var column = this.props.column;

        var click = this.props.onSeatClick;
        click(row, column);
      }
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus() {
      var row = this.props.row;
      var column = this.props.column;

      var focus = this.props.onSeatFocus;
      focus(row, column);
    }
  }, {
    key: 'render',
    value: function render() {
      var classNames = "seatChart-seat" + " ";
      if (this.props.seat.status == "unavailable") {
        classNames += this.props.seat.status;
      } else {
        classNames += this.props.seat.type;
      }

      var key = _shortid2.default.generate();
      var text = this.props.seat.label;

      var seat = _react2.default.createElement(
        'div',
        { className: classNames, key: key, onClick: this.handleClick, onFocus: this.handleFocus },
        text
      );

      return _react2.default.createElement(
        'div',
        { key: _shortid2.default.generate(), className: 'seatChart-cell' },
        seat
      );
    }
  }]);

  return Seat;
}(_react2.default.Component);

exports.default = Seat;


Seat.Accessible = _AccessibleSeat2.default;
Seat.Spacer = _Spacer2.default;