'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _shortid = require('shortid');

var _shortid2 = _interopRequireDefault(_shortid);

var _SeatingRow = require('./SeatingRow');

var _SeatingRow2 = _interopRequireDefault(_SeatingRow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function copyObject(obj) {
  return Object.assign({}, obj);
}

function cloneDoubleNested(list) {
  return list.map(function (row) {
    return row.map(function (item) {
      return copyObject(item);
    });
  });
}

var SeatingChart = function (_React$Component) {
  _inherits(SeatingChart, _React$Component);

  function SeatingChart(props) {
    _classCallCheck(this, SeatingChart);

    var _this = _possibleConstructorReturn(this, (SeatingChart.__proto__ || Object.getPrototypeOf(SeatingChart)).call(this, props));

    var seats = props.seats;
    var original = cloneDoubleNested(seats);

    var naming = props.naming;
    if (naming == null) {
      var rows = [];
      var columns = [];
      for (var i = 0; i < seats.length; i++) {
        rows.push(i.toString());
        columns.push(i.toString());
      }

      naming.rows = rows;
      naming.columns = columns;
    }

    _this.state = {
      naming: naming,
      seats: seats,

      original: original
    };

    _this.handleClick = _this.handleClick.bind(_this);
    _this.handleFocus = _this.handleFocus.bind(_this);
    return _this;
  }

  _createClass(SeatingChart, [{
    key: 'handleClick',
    value: function handleClick(row, column) {
      var seats = cloneDoubleNested(this.state.seats);

      var seat = seats[row][column];

      if (seat.seatType === "selected") {

        var original = copyObject(this.state.original[row][column]);
        seat.seatType = original.seatType;
      } else {
        seat.seatType = "selected";
      }

      if (this.props.onClick != undefined) {
        this.props.onClick(row, column, seats);
      }

      this.setState({ seats: seats });
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(row, column) {
      var seats = cloneDoubleNested(this.state.seats);

      var seat = seats[row][column];

      if (seat.status === "available") {
        seat.status = "focused";
      } else {
        var original = copyObject(this.state.original[row][column]);
        seat.status = original.status;
      }

      if (this.props.onFocus != undefined) {
        this.props.onFocus(row, column, seats);
      }

      this.setState({ seats: seats });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'seatChart-container' },
        this.state.seats.map(function (row, i) {
          return _react2.default.createElement(_SeatingRow2.default, { seats: row, onSeatClick: this.handleClick, onSeatFocus: this.handleFocus, key: _shortid2.default.generate(), num: i });
        }, this)
      );
    }
  }]);

  return SeatingChart;
}(_react2.default.Component);

exports.default = SeatingChart;